<!DOCTYPE html>
<html lang="zxx">

<head>
  <meta charset="utf-8">
  <title>MDEF/Wildcard week</title>

  <!-- mobile responsive meta -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">

  <!-- ** Plugins Needed for the Project ** -->
  <!-- Bootstrap -->
  <link rel="stylesheet" href="../plugins/bootstrap/bootstrap.min.css">
  <link rel="stylesheet" href="../plugins/themify/css/themify-icons.css">
  <link rel="stylesheet" href="../plugins/counto/animate.css">
  <link rel="stylesheet" href="../plugins/aos/aos.css">
  <link rel="stylesheet" href="../plugins/owl-carousel/owl.carousel.min.css">
  <link rel="stylesheet" href="../plugins/owl-carousel/owl.theme.default.min.css">
  <link rel="stylesheet" href="../plugins/magnific-popup/magnific-popup.css">
  <link rel="stylesheet" href="../plugins/animated-text/animated-text.css">

  <!-- Main Stylesheet -->
  <link href="../designspace/style.css" rel="stylesheet">

</head>


<body>

<!-- Navigation Start -->
<!-- Header Start -->

<div class= "header">

  <nav class="navbar navbar-expand-lg  main-nav " id="navbar">
  	<div class="container">
  	  <a class="navbar-brand" href="../index.html">
  	  	<img src="../images/logo.png" alt="" class="img-fluid">
  	  </a>


  	  <button class="navbar-toggler collapsed" type="button" data-toggle="collapse" data-target="#navbarsExample09" aria-controls="navbarsExample09" aria-expanded="false" aria-label="Toggle navigation">
  		<span class="ti-align-justify"></span>
  	  </button>

  		  <div class="collapse navbar-collapse" id="navbarsExample09">
  			<ul class="navbar-nav ml-auto">

  			  <li class="nav-item  active"><a class="nav-link" href="../index.html">Home</a></li>

  			  <li class="nav-item dropdown active">
  					<a class="nav-link dropdown-toggle" href="#" id="dropdown02" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">Reflection</a>
  					<ul class="dropdown-menu" aria-labelledby="dropdown02">
  						<li><a class="dropdown-item" href="../blog-grid.html">Term 1</a></li>
  						<li><a class="dropdown-item" href="../term2.html">Term 2</a></li>
  						<li><a class="dropdown-item" href="../term3.html">Term 3</a></li>
  					</ul>
  			  </li>

          <li class="nav-item dropdown active">
           <a class="nav-link dropdown-toggle" href="#" id="dropdown02" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">Research</a>
           <ul class="dropdown-menu" aria-labelledby="dropdown02">
             <li><a class="dropdown-item" href="../designspace/design-space.html">Design Space</a></li>
             <li><a class="dropdown-item" href="../materials.html">Materiality</a></li>
           </ul>
         </li>

  			   <li class="nav-item"><a class="nav-link" href="../contact.html">GitLab</a></li>
           <li class="nav-item  active"><a class="nav-link" href="../myself.html">About</a></li>

  			</ul>
  		</div>
  	</div>
  </nav>
</div>
<!-- Header Close -->


<section class="page-title section pb-0">
  <div class="container">
    <div class="row">
      <div class="col-lg-12">
        <div class="text-center">
          <h1 class="text-capitalize mb-0 text-lg">Wildcard week</h1>
        </div>
      </div>
    </div>
  </div>
</section>



	<div class="fabclass">
              <br> </br>
              <h2>Controling remotely a machine </h2>
              <br> </br>
               <img src="cncsea1.jpg" alt="shaders" class="img-fluid fabimage">
               <br> </br>
               <h5>The project is a about setting up a remote control for a CNC machine. Oscar and Edu created this amazing project and documented everything on gitlab so you can replicate it of you want. This is the link: <a href="https://gitlab.com/fablabbcn-projects/learning/the-cnc-by-the-sea"><h9>The CNC by the sea</h9></a> </h5>
                <p>The network was built using a Raspberry-Pi, and through an interface we could connect to the machine. First we had to connect to the IAAC routers which had some static IPs - some extra addresses configured for a specific device.
                  From the IP, we access the Raspberry-Pi, through a "proxy server" and then use CNCJS to access the machine who is using and arduino and using Marlin code (GCODE for CNC machines). </p>
                <br> </br>
                 <img src="cncsea.jpg" alt="shaders" class="img-fluid fabimage">
                <h3>1. Creating the file:</h3>
                <p>The first step is to create a file in Photoshop/ Illustrator and then export it as png. The file should be maximun 700mmx700mm, which is the size of the bed of the machine. Here is the png file that
                I used:</p>

                   <img src="oneline.png" alt="shaders" class="img-fluid fabimage">

                 <br> </br>
                 <h3>2. Generating the g-code:</h3>
                 <p>The language of these machines is basically a list of all the coordinated that the driver has follow in order to move. So it s the x,y and z coordinates of each moment. To read more you can go here: <a href="https://marlinfw.org/meta/gcode/">https://marlinfw.org/meta/gcode/</a>.
                   In order to generate this kind of file
                   we go to <b>mods</b> (<a href="http://mods.cba.mit.edu/">http://mods.cba.mit.edu/</a>"), we right-click and we choose <b> programs > open server programs > machines > G-code > mill 2d png</b>.
                   Afterwards upload your png, in the<b> read png module</b>, and make sure you have the same DPI as your image (if you have a different one then it will scale up or down your image).</p>
                   <p>Afterwards go to the <b>mill raster 2d module</b> and use the settings :
                     <ul><li>Tool diameter set it to 3mm </li>
                         <li>Cut depth and max depth we used -10mm (the table was supposed to be 0 and the sand is abobe it at a height of 22mm)  </li>
                         <li>and for the Offset stepover 1 </li> </p></ul>

                    <p>For the <b>path to G-code</b> we used these settings:

                      <ul><li>  Cut speed: 3000mm/s</li>
                         <li>Plunge speed: 3000mm/s</li>
                         <li>Jog speed: 3000mm/s </li>
                         <li>Jog height: 30mm (the sand is 20mm high) </li>
                         <li>Spindle speed: 1000 </li>
                         <li>Coolant: off  </li>
                         <li>Format: mm  </li></ul>

                          <img src="modswildcard.jpg" alt="mods" class="img-fluid fabimage">
                               <br> </br>

                          <p>The problem that many of had was that mods or fabmodules didn't generate the gcode and instead they made an error code with only 10 lines. So I also tried with Fabmodules but again the file
                            is not getting saved.</p>

                          <img src="fabmodules.jpg" alt="fabmodules" class="img-fluid fabimage">
                               <br> </br>

                          <p>So, in the end what worked better for me was the grasshopper script, which translates the curves to g-code.</p>

                            <img src="kraken.jpg" alt="kraken" class="img-fluid fabimage">
                                 <br> </br>
                            <p>Here is the grasshopper file : <a href="facesforgcode.gh"><b>Faces_grasshopper</b></a></p>

                            <p>After we generate it, we can open it with atom in order to edit it. For example, we can add some initial steps: G21 to set the units to millimeters, G28 G28 XY to go to X & Y Home coordinates,
                              G0 Z30 to move the screwdriver above the sand and F3000 to set the feed rate </p>


                            <img src="atomgcode.jpg" alt="atom" class="img-fluid fabimage">
                                 <br> </br>





                           <h3>3. Go to the remote CNC controller:</h3>

                           <p>First, we had to go to <a href="https://thecncbythesea.hopto.org/#/workspace">https://thecncbythesea.hopto.org/#/workspace</a> to acess the controller page.
                             There you should add the JSON file:  <a href="json.json" json file> <b>JSON file</b> </a>, by going to the Settings > Workspace, at the bottom right click on Import, and select the JSON file</p>
                           <p>On the left click Connection, select /dev/ttyUSB0 in the Port dropdown. Click on the Open button. This is the interface that we will be using to send the gcode and see how it moves</p>

                           <p>The Fabguys had connected two cameras that we could access remotely to see the live straming of the machine, we could enter at the <a href="http://91.126.132.4:8080/?action=stream">http://91.126.132.4:8080/?action=stream</a> and we could connect them to the console in the Connect an IP camera. </p>

                            <img src="kraken.png" alt="shaders" class="img-fluid fabimage">
                            <br> </br>
                            <p>We could also test if it worked by typing some simple commands in the console as: G0 Z30 or G28 </p>

                          

                            <p>This was the first "hello" that I wrote using the cnc machine with this gcode that I generated: <a href="hello.gcode"><b>hello G-code</b></a></p>
                            <br> </br>
                            <img src="hello.jpg" alt="hello" class="img-fluid fabimage">
                            <br> </br>
                            <img src="screw.jpg" alt="screw" class="img-fluid fabimage">
                            <br> </br>
                            <img src="cncsea3.jpg" alt="cncsea3" class="img-fluid fabimage">
                            <br> </br>












        </div>
      </div>



    <section class="footer">
    	<div class="container">
    		<div class="row ">
    			<div class="col-lg-6">
    			</div>
    			<div class="col-lg-6">
    				<div class="widget footer-widget text-lg-right mt-5 mt-lg-0">
    					<ul class="list-inline mb-0">

    					</ul>
    				</div>
    			</div>
    		</div>
    	</div>
    </section>

</body>

<!-- jQuery -->
<script src="../plugins/jQuery/jquery.min.js"></script>
<!-- Bootstrap JS -->
<script src="../plugins/bootstrap/bootstrap.min.js"></script>
<script src="../plugins/aos/aos.js"></script>
<script src="../plugins/owl-carousel/owl.carousel.min.js"></script>
<script src="../plugins/shuffle/shuffle.min.js"></script>
<script src="../plugins/magnific-popup/jquery.magnific-popup.min.js"></script>
<script src="../plugins/animated-text/animated-text.js"></script>
<script src="../plugins/counto/apear.js"></script>
<script src="../plugins/counto/counTo.js"></script>

 <!-- Google Map -->
<script src="../plugins/google-map/map.js"></script>
<!-- Main Script -->
<script src="js/script.js"></script>

</html>
